



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>记录一个简单的dbcp数据连接池</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">记录一个简单的dbcp数据连接池</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 04:07:11 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>这个示例用到了ThreadLocal与dbcp，我觉得有点意思，就整理了下。使用dbcp，肯定要导入commons-dbcp.jar包。下面直接贴DBUtil代码：</p>
<div>
<pre class="prettyprint linenums">public class DBUtil {<br />
    private static DataSource ds;  //定义一个数据连接池<br />
    //threadLocal是线程的局部变量，它的实例通常是类中的 private static 字段<br />
    private static ThreadLocal&lt;Connection&gt; connLocal=new ThreadLocal&lt;Connection&gt;();<br />
    static{<br />
        Properties props=new Properties();<br />
        try {<br />
            props.load(DBUtil.class.getClassLoader().getResourceAsStream("dbcp.properties"));<br />
            ds=BasicDataSourceFactory.createDataSource(props);<br />
        } catch (Exception e) {<br />
            e.printStackTrace();<br />
        }<br />
    }<br />
    public static Connection getConnection() throws SQLException{<br />
        Connection conn=connLocal.get();<br />
        if(conn==null){<br />
            conn=ds.getConnection();<br />
            connLocal.set(conn);<br />
        }<br />
        return conn;<br />
    }<br />
    public static void close() throws SQLException{<br />
        Connection conn=connLocal.get();<br />
        connLocal.set(null);//清空线程局部变量的内容<br />
        if(conn!=null){<br />
            try {<br />
                conn.close();<br />
            } catch (Exception e) {e.printStackTrace();}<br />
        }<br />
    }<br />
}</pre>
</div>
<p>下面是dbcp.properties配置内容：</p>
<div>
<pre class="prettyprint linenums">driverClassName=com.mysql.jdbc.Driver<br />
url=jdbc:mysql://localhost:3306/kyle1970<br />
username=root<br />
password=kyle1970<br />
initialSize=2<br />
maxActive=15<br />
maxIdle=2<br />
minIdle=1<br />
maxWait=30000</pre>
</div>
<p>个人感觉做了第二次的缓存。而ThreadLocal是每个线程都有的一个存储空间。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k5j738.html">jsonp的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1my359.html">UVa 11468 &lpar;AC自动机 概率DP&rpar; Substring</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oxg739.html">Linux shell中的一个问题 &dollar;&lbrace;&rcub;带正则匹配的表达式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyde5kxq.html">USACO Section 4&period;2 The Perfect Stall（二分图匹配）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjdp3r8.html">AeroGear&period;js 1&period;2&period;0 发布，手机Web应用脚手架 - 开源中国社区</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjoyvy8.html">&lbrack;转&rsqb;SSL协议与数字证书原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo3grdq.html">html之改变图片透明度而不改变文字的透明度--两种方法实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk645v8.html">201521123098 《Java程序设计》第1周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rwwj08.html">哪些人才适合转行学习UI设计？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j17d2e9.html">strlen函数的汇编实现分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllz50eq.html">【IT笔试面试题整理】删除无序链表中重复的节点</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pkloeq.html">myschool 1204</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpg0el9.html">net&period;sf&period;json&period;JSONOBJECT&period;fromObject 与 com&period;alibaba&period;fastjson&period;JSONObject&period;parseObject</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql124219.html">unity3D角色代码控制问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlmrz39.html">Java利用ScriptEngineManager对计算公式的支持</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o47g0lq.html">TortoiseSVN解决冲突</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpnjyz9.html">vim -d file01 file02 diff file01 file02 对比两文件的不同</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2xd2ew9.html">&lbrack;转&rsqb;HTML标签元素的分类</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pmx6x79.html">glibc中malloc的详细解释&lowbar;转</a>
		</li>
						<li><a href="https://www.batexi.com/a/8od342xq.html">MooseFS分布式文件系统介绍</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90rkywj9.html">Python开发&mdash;&mdash;基础</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4r36e9.html">MySQL数据查询之单表查询</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjrk669.html">探索未知种族之osg类生物---渲染遍历之Renderer简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25yy7oq.html">linux debian 9  &sol; centos 7配置postgresSQL数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5kw7rq.html">第二阶段第二次spring会议</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1l2oeq.html">centos6&period;9 编译安装 zabbix-3&period;0&period;15</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw260k8.html">javabean的特点</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw25j78.html">gitlab 搭建自己的源代码管理器</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wg16gq.html">桌面管理工具 RedisDesktopManager 0&period;8&period;8</a>
			</li>
						<li><a href="https://www.batexi.com/a/95g7116q.html">array&lowbar;flip&lpar;&rpar;函数</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
